/***************************************************************************
 *   Copyright (C) 2008  Antony Martin <martin(dot)antony(at)yahoo(dot)fr> *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 17/04/2008
   derniere modification : 17/04/2008 */

#ifndef SCEBILLBOARD_H
#define SCEBILLBOARD_H

#include <SCE/utils/SCEVector.h>
#include <SCE/utils/SCEMatrix.h>

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct sce_sbillboard SCE_SBillboard;
struct sce_sbillboard
{
    SCE_TVector3 normal;   /* normale par defaut */
    int x, y, z;           /* angles utilises pour le billboarding */
    SCE_TVector3 campos;   /* position de la camera */
};

/* initialise une structure de billboard */
void SCE_Billboard_Init (SCE_SBillboard*);

/* cree un billboard (entre nous cette fonction est inutile) */
SCE_SBillboard* SCE_Billboard_Create (void);
/* supprime un billboard */
void SCE_Billboard_Delete (SCE_SBillboard*);

/* defini la normale de l'objet */
void SCE_Billboard_SetNormal (SCE_SBillboard*, float, float, float);
void SCE_Billboard_SetNormalv (SCE_SBillboard*, SCE_TVector3);

/* defini les axes a prendre en compte lors du billboard */
void SCE_Billboard_SetAxis (SCE_SBillboard*, int, int, int);
/* indique les angles qui sont pris en compte */
void SCE_Billboard_GetAxis (SCE_SBillboard*, int*, int*, int*);

/* defini la position de la camera */
void SCE_Billboard_SetCameraPosition (SCE_SBillboard*, float, float, float);
void SCE_Billboard_SetCameraPositionv (SCE_SBillboard*, SCE_TVector3);
/* indique la position courante de la camera */
void SCE_Billboard_GetCameraPositionv (SCE_SBillboard*, SCE_TVector3);

/* retourne la matrice a appliquer d'apres la billboard donne */
void SCE_Billboard_GetMatrix (SCE_SBillboard*, SCE_TMatrix4);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* guard */
